// Smart Shell Programm

// Tetstat 3 Systemprogrammierung
// Karsten Wolke
// 3. Semester
// 06.11.2000
# include "shell.h"
#define maxlength 80
int main(){
	char command[maxlength];				//einzulesendes Kommando
	int i,j,prozess_id,background;
	char *argument_list[maxlength];
	char *modified_argument_list[maxlength];
	char *output_file;
	char *input_file;
	int endlos_schleife=0;
	printf("Smart Shell Program\n");
	printf("Copyright by K.Wolke\n");
	printf("Version 08.11.2000\n\n\n");
	endlos_schleife=1;
	while(endlos_schleife){
	  output_file=NULL;
	  input_file=NULL;
	  background=1;						//Hintergrundprozess ausschalten
	  for (i=0;i<maxlength;i++){
	  	argument_list[i]='\0';
		modified_argument_list[i]='\0';
	  }
	  do{							//Eingabe eines K.
	     printf ("Smart Shell ->");
	     gets(command);
	  }while (strlen(command) == 0);   			//solange wiederholen bis K. eingegeben ist
	  argument_list[0]=strtok(command ," "); 		//erstes Argument in den Speicher holen
	  if (strcmp(argument_list[0], "exit") == 0){ 		//Bei Eingabe von exit wird das Programm beendet
	      exit(0);
	  }
	  modified_argument_list[0]=argument_list[0];
	  for (i=1; (argument_list[i]=strtok(NULL," ")) !=NULL;i++);
	  i=1;
	  j=1;
	  while(argument_list[i]!=NULL){    			//weitere Argumente in den speicher lesen
             switch(*argument_list[i]){
		case '<' : {					// Eingabeumlenkung
			    i++;
			    input_file=argument_list[i];		
	                    printf("umgelenkt < \n");
			    i=i++;
			    break;  
			   }				
		case '>' : {					// Ausgabeumlenkung
                            i++;				
			    output_file=argument_list[i];
			    printf("umgelenkt > \n");
			    i=i++;
			    break;  
			   }
		case '$' : {					// Variablenexpansion
                   	    i++;
			    modified_argument_list[j]=getenv(argument_list[i]);
			    j++;
			    i++;		
			    printf("Variablenexpansion");
			    break;  
			   }
		 case '&'   :  {
			    i++;
                 	    background=0;
			    break;
		default :   {
                            modified_argument_list[j]=argument_list[i];
			    i++;
			    j++;
			    break;	
			    }
                    }

	     }
	  }
	prozess_id=fork();					//Kind Prozess aufrufen und PID merken;
	if (prozess_id==0)					//Schauen ob Kindprozess
	{
	  if (input_file != NULL){	
	    close(0);						//Schlieen vom Standart Imput Stream
	    fopen(input_file,"r");		//ffnen der Datei zum lesen
	  }
	  if (output_file != NULL){
	    close(1);						//Schlieen vom Standart Output Stream
 	    fopen(output_file,"w");				//ffnen der Datei zum schreiben
	  }	
	  if (execvp(modified_argument_list[0],modified_argument_list) !=0)   	//Befehl wird uasgefhrt
	  {
	    printf("Command not found \n");			//Fehlermeldung bei Fehlern
	    exit(-1);						//Kindprozess wird mit Fehler beendet
	  }
	}
	printf("Prozess-ID %d \n",prozess_id);			//Nur zu Information
	if (background == 1)					//Wenn kein & angegeben dann warten
	{
	   
	   waitpid(prozess_id,0,0);
	   printf("Auf Prozess gewartet \n");
	}
       }
}
